'use strict'
Object.defineProperty(exports, '__esModule', { value: true })
exports.getHistorySection = void 0
const util_js_1 = require('./util.js')
// Get History Section
function getHistorySection(data) {
	// Prepare
	let link = null
	const file = data.filenamesForReadmeFiles.history
	if (file) {
		link = util_js_1.getLink({
			url: util_js_1.getFileUrl(data, file),
			text: `Discover the release history by heading on over to the <code>${file}</code> file.`,
		})
	} else if (data.github.slug) {
		link = util_js_1.getLink({
			url: `https://github.com/${data.github.slug}/releases`,
			text:
				'Discover the release history by heading on over to the releases page.',
		})
	} else {
		throw new Error(
			'History section either requires a HISTORY file or a Github repository'
		)
	}
	// Return
	return '<h2>History</h2>\n\n' + link
}
exports.getHistorySection = getHistorySection
